/* types.c -- find out size of data types */

/* this is how the output look on Mac OS X

type      bytes
---------------
char      1
char *    4
void *    4
short int 2
int       4
long      4
long int  4
long long 8
float     4
double    8
wchar_t   4

*/

#include <stdio.h>
#include <stdlib.h>
#include <wchar.h>


int main(int argc, char * argv[])
{
printf("\n");
printf("type      bytes\n");
printf("---------------\n");
printf("char        %d\n", sizeof(char));
printf("char *      %d\n", sizeof(char *));
printf("void *      %d\n", sizeof(void *));
printf("short int   %d\n", sizeof(short int));
printf("int         %d\n", sizeof(int));
printf("long        %d\n", sizeof(long));
printf("long int    %d\n", sizeof(long int));
printf("long long   %d\n", sizeof(long long));
printf("float       %d\n", sizeof(float));
printf("double      %d\n", sizeof(double));
printf("long double %d\n", sizeof(long double));
printf("wchar_t     %d\n", sizeof(wchar_t));

printf("\n");
printf("format input              output\n");
printf("--------------------------------\n");
printf("%%d    0xffffffff         %d\n", 0xffffffff);
printf("%%u    0xffffffff         %u\n", 0xffffffff);
printf("%%d    0x7fffffffffffffff %d\n", 0x7fffffffffffffffLL);
printf("%%u    0x7fffffffffffffff %u\n", 0x7fffffffffffffffLL);
printf("%%x    0x7fffffffffffffff %x\n", 0x7fffffffffffffffLL);
printf("%%X    0x7fffffffffffffff %x\n", 0x7fffffffffffffffLL);
#ifndef TRU64
printf("%%lld  0x7fffffffffffffff %lld\n", 0x7fffffffffffffffLL);
printf("%%lld  0xFfffffffffffffff %lld\n", 0xFFFFFFFFFFFFFFFFLL);
printf("%%llu  0xFfffffffffffffff %llu\n", 0xFFFFFFFFFFFFFFFFLL);
#else
printf("%%ld  0x7fffffffffffffff %ld\n", 0x7fffffffffffffffLL);
printf("%%ld  0xFfffffffffffffff %ld\n", 0xFFFFFFFFFFFFFFFFLL);
printf("%%lu  0xFfffffffffffffff %lu\n", 0xFFFFFFFFFFFFFFFFLL);
#endif

exit(0);
}


